﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Styles;

namespace UltraChartDrillChart
{
    public partial class Form1 : Form
    {
        private const int MAX_DRILL = 3;
        private const int MIN_DRILL = 1;
        private int currentDrill = 1;
        private DataTable dtCustomers;
        private DataTable dtOrders;
        public Form1()
        {
            InitializeComponent();

            dtCustomers = new DataTable();
            dtCustomers.Columns.Add("CustomerID", typeof(int));
            dtCustomers.Columns.Add("CustomerName", typeof(string));

            dtCustomers.Rows.Add(1, "IBM");
            dtCustomers.Rows.Add(2, "HP");
            dtCustomers.Rows.Add(3, "Dell");
            dtCustomers.Rows.Add(4, "Asus");
            dtCustomers.Rows.Add(5, "Sony");


            dtOrders = new DataTable();
            dtOrders.Columns.Add("OrderId", typeof(int));
            dtOrders.Columns.Add("OrderDescription", typeof(string));

            dtOrders.Rows.Add(1, "Test 1");
            dtOrders.Rows.Add(2, "Test 2");
            dtOrders.Rows.Add(3, "Test 3");
            dtOrders.Rows.Add(4, "Test 4");
            dtOrders.Rows.Add(5, "Test 5");


            this.ultraChart1.ColorModel.CustomPalette = new Color[] { Color.DarkSalmon};
            ultraChart1.ChartType = ChartType.ColumnChart;
            ultraChart1.Axis.X.Labels.Visible = false;
            ultraChart1.DataSource = dtCustomers;
        }

        private void DrillDown()
        {
            currentDrill += 1;
            if (currentDrill > MAX_DRILL) currentDrill = MAX_DRILL;
        }


        private void DrillBack()
        {
            currentDrill -= 1;
            if (currentDrill < MIN_DRILL) currentDrill = MIN_DRILL;
        }

        private void BuildChart(int FieldValue)
        {
            this.ultraChart1.ColorModel.CustomPalette = new Color[] { Color.Red, Color.Black, Color.Yellow, Color.Violet, Color.HotPink };
            this.ultraChart1.ChartType = ChartType.PieChart3D;
            this.ultraChart1.Legend.Visible = true;
            this.ultraChart1.Data.DataSource = dtOrders;
        }

        private void ultraChart1_ChartDataClicked(object sender, Infragistics.UltraChart.Shared.Events.ChartDataEventArgs e)
        {
            if (currentDrill == MAX_DRILL) return;
            this.DrillDown();
            this.BuildChart(e.DataColumn);
        }

    }
}
